package sk.tuke.gamestudio.game.mines.webui;


import sk.tuke.gamestudio.game.mines.core.Tile;
import sk.tuke.gamestudio.game.mines.core.TileState;

public class ViewTile<T extends Tile> {
    private final T tile;
    private final int row;
    private final int column;

    public ViewTile(T tile, int row, int column) {

        this.tile = tile;
        this.row = row;
        this.column = column;
    }

    public T getTile() {
        return tile;
    }

    public int getRow() {
        return row;
    }

    public int getColumn() {
        return column;
    }

    public boolean isOpen() {
        return tile.getState() == TileState.OPEN;
    }

    public boolean isMarked() {
        return tile.getState() == TileState.MARKED;
    }

    public String getState() {
        return tile.getState().toString().toLowerCase();
    }

    public String getType() {
        return tile.getClass().getSimpleName().toLowerCase();
    }

}